'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactFlex = require('react-flex');

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _join = require('../../../join');

var _join2 = _interopRequireDefault(_join);

var _bemFactory = require('../../../bemFactory');

var _bemFactory2 = _interopRequireDefault(_bemFactory);

var _renderHeader = require('./renderHeader');

var _renderHeader2 = _interopRequireDefault(_renderHeader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cellBem = (0, _bemFactory2.default)('react-datagrid__cell');
var headerBem = (0, _bemFactory2.default)('react-datagrid__column-header');

var Cell = function (_Component) {
  _inherits(Cell, _Component);

  function Cell() {
    _classCallCheck(this, Cell);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Cell).apply(this, arguments));
  }

  _createClass(Cell, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.onMount) {
        this.props.onMount(this.props, this);
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      if (typeof nextProps.shouldComponentUpdate === 'function') {
        return nextProps.shouldComponentUpdate(nextProps, this.props);
      }

      return !(0, _shallowequal2.default)(nextProps, this.props);
    }
  }, {
    key: 'prepareStyle',
    value: function prepareStyle(props) {
      var style = (0, _objectAssign2.default)({}, props.style);

      var minWidth = props.minWidth;
      var maxWidth = props.maxWidth;
      var defaultWidth = props.defaultWidth;
      var width = props.width;


      if (width === undefined && defaultWidth !== undefined) {
        width = defaultWidth;
      }

      if (width && minWidth && width < minWidth) {
        width = minWidth;
      }

      if (minWidth != null) {
        style.minWidth = minWidth;
      }

      if (maxWidth != null) {
        style.maxWidth = maxWidth;
      }

      if (width != null) {
        if (maxWidth != null && width > maxWidth) {
          width = maxWidth;
        }
        if (minWidth != null && width < minWidth) {
          width = minWidth;
        }

        style.minWidth = style.maxWidth = style.width = width;
      }

      return style;
    }
  }, {
    key: 'prepareClassName',
    value: function prepareClassName(props) {
      var isHeaderCell = props.headerCell;
      var headerCellDefaultClassName = props.headerCellDefaultClassName;
      var cellDefaultClassName = props.cellDefaultClassName;


      var baseClassName = isHeaderCell ? headerCellDefaultClassName : cellDefaultClassName;

      var className = (0, _join2.default)(props.className, baseClassName, props.textAlign && baseClassName + '--align-' + props.textAlign, props.first && baseClassName + '--first', props.last && baseClassName + '--last');

      if (isHeaderCell) {
        className = (0, _join2.default)(className, props.titleClassName, props.sortable && baseClassName + '--sortable', props.resizable && baseClassName + '--resizable', props.lastInGroup && baseClassName + '--last-in-group');
      }

      return className;
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      var data = props.data;
      var value = props.value;
      var name = props.name;
      var headerCell = props.headerCell;
      var renderCell = props.render;


      var className = this.prepareClassName(props);
      var style = this.prepareStyle(props);

      var cellProps = (0, _objectAssign2.default)({}, props, {
        value: value,
        name: name,
        className: className,
        children: value,
        style: style,
        onClick: this.onClick,
        onMouseUp: this.onMouseUp
      });

      // TODO:
      // title can be
      if (headerCell) {
        // I want to add onClick event handler so I can
        // use it for sort
        cellProps = this.prepareHeaderCellProps(cellProps);
      }

      if (renderCell && !headerCell) {
        cellProps.children = renderCell({ value: value, data: data, cellProps: cellProps });
      }

      return headerCell ? (0, _renderHeader2.default)(cellProps) : _react2.default.createElement(_reactFlex.Item, _extends({}, cellProps, {
        title: null,
        data: null
      }));
    }
  }, {
    key: 'prepareHeaderCellProps',
    value: function prepareHeaderCellProps(cellProps) {
      var props = this.props;
      var children = cellProps.children;


      var sortTools = this.getSortTools(cellProps.sortInfo ? cellProps.sortInfo.dir : null, cellProps);

      cellProps.children = [children, sortTools];

      if (cellProps.sortInfo && cellProps.sortInfo.dir) {
        var dirName = cellProps.sortInfo.dir == 1 ? 'asc' : 'desc';

        cellProps.className = (0, _join2.default)(cellProps.className, props.headerCellDefaultClassName + '--sort-' + dirName);
      }

      cellProps.onResizeMouseDown = this.onResizeMouseDown.bind(this, cellProps);

      return cellProps;
    }
  }, {
    key: 'onResizeMouseDown',
    value: function onResizeMouseDown(cellProps, event) {
      if (this.props.onResizeMouseDown) {
        this.props.onResizeMouseDown(cellProps, (0, _reactDom.findDOMNode)(this), event);
      }
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp(event) {
      event.stopPropagation();
      event.preventDefault();
      console.log('mouse up');
    }
  }, {
    key: 'onClick',
    value: function onClick(event) {

      console.log('click');
      if (this.props.onClick) {
        this.props.onClick(event, this.props);
      }

      if (this.props.headerCell && this.props.sortable) {
        this.props.onSortClick(this.props);
      }
    }

    // direction can be 1, -1 or null

  }, {
    key: 'getSortTools',
    value: function getSortTools() {
      var direction = arguments.length <= 0 || arguments[0] === undefined ? null : arguments[0];
      var cellProps = arguments[1];
      var props = this.props;


      if (props.renderSortTool) {
        return props.renderSortTool(direction, cellProps);
      }

      var visibilityClassName = '';

      if (!direction) {
        visibilityClassName = 'react-datagrid__icon-sort--hidden';
      }

      return direction === -1 ? _react2.default.createElement(
        'svg',
        { className: (0, _join2.default)(visibilityClassName, 'react-datagrid__icon-sort-desc'), height: '20', viewBox: '0 0 24 24', width: '20', xmlns: 'http://www.w3.org/2000/svg' },
        _react2.default.createElement('path', { d: 'M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z' })
      ) : _react2.default.createElement(
        'svg',
        { className: (0, _join2.default)(visibilityClassName, 'react-datagrid__icon-sort-asc'), height: '20', viewBox: '0 0 24 24', width: '20', xmlns: 'http://www.w3.org/2000/svg' },
        _react2.default.createElement('path', { d: 'M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z' })
      );
    }
  }]);

  return Cell;
}(_reactClass2.default);

exports.default = Cell;


var emptyFn = function emptyFn() {};

Cell.defaultProps = {
  cellDefaultClassName: cellBem(),
  headerCellDefaultClassName: headerBem(),

  minWidth: 40,

  onSortClick: emptyFn
};

Cell.propTypes = {
  render: _react.PropTypes.func,
  renderSortTool: _react.PropTypes.func,

  style: _react.PropTypes.object,
  className: _react.PropTypes.string,

  data: _react.PropTypes.object,
  name: _react.PropTypes.string,
  value: _react.PropTypes.node,

  width: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  maxWidth: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  minWidth: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),

  flex: _react.PropTypes.number,

  onClick: _react.PropTypes.func
};