"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var getDataRangeToRender = function getDataRangeToRender(bodyHeight, itemHeight, scrollTop) {
  var extraRows = arguments.length <= 3 || arguments[3] === undefined ? 4 : arguments[3];

  extraRows += 2;

  var noItemsToRender = parseInt(bodyHeight / itemHeight + extraRows, 10);

  // noItemsToRender must be odd
  if (noItemsToRender % 2 === 0) {
    noItemsToRender += 1;
  }

  if (scrollTop <= extraRows / 2 * itemHeight) {
    // reder first n items
    return {
      from: 0,
      to: noItemsToRender
    };
  }

  var renderFrom = parseInt(scrollTop / itemHeight - extraRows / 2, 10);

  // fisrt must be even
  if (renderFrom % 2 !== 0) {
    renderFrom += 1;
  }

  var rangeToRender = {
    from: renderFrom,
    to: renderFrom + noItemsToRender
  };

  return rangeToRender;
};

exports.default = getDataRangeToRender;