'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref, _ref2, event) {
  var region = _ref.region;
  var headerRegion = _ref.headerRegion;
  var constrainTo = _ref.constrainTo;
  var columnHeaderNodes = _ref.columnHeaderNodes;
  var columns = _ref.columns;
  var index = _ref.index;
  var initialSize = _ref.initialSize;
  var extraOffset = _ref.extraOffset;
  var _ref2$onResizeDragIni = _ref2.onResizeDragInit;
  var onResizeDragInit = _ref2$onResizeDragIni === undefined ? emptyFn : _ref2$onResizeDragIni;
  var _ref2$onResizeDragSta = _ref2.onResizeDragStart;
  var onResizeDragStart = _ref2$onResizeDragSta === undefined ? emptyFn : _ref2$onResizeDragSta;
  var _ref2$onResizeDrag = _ref2.onResizeDrag;
  var onResizeDrag = _ref2$onResizeDrag === undefined ? emptyFn : _ref2$onResizeDrag;
  var _ref2$onResizeDrop = _ref2.onResizeDrop;
  var onResizeDrop = _ref2$onResizeDrop === undefined ? emptyFn : _ref2$onResizeDrop;

  event.preventDefault();

  var column = columns[index];

  var initialLeft = region.left - headerRegion.left;

  var isContrained = function isContrained(config) {
    var constrained = config.dragRegion.left == constrainTo.left || config.dragRegion.right == constrainTo.right;

    return constrained;
  };

  (0, _dragHelper2.default)(event, {
    constrainTo: constrainTo,
    region: region,
    onDragInit: onResizeDragInit.bind(this, {
      offset: initialLeft,
      region: region,
      initialLeft: initialLeft
    }),
    onDragStart: function onDragStart(e, config) {
      var constrained = isContrained(config);

      onResizeDragStart({
        initialLeft: initialLeft,
        offset: initialLeft,
        constrained: constrained,
        resizing: true,
        region: region,
        column: column
      });
    },
    onDrag: function onDrag(e, config) {
      var diff = config.diff.left;
      var offset = initialLeft + diff;
      var constrained = isContrained(config);

      onResizeDrag({
        constrained: constrained,
        initialLeft: initialLeft,
        diff: diff,
        offset: offset,
        region: region,
        column: column
      });
    },
    onDrop: function onDrop(e, config) {
      var diff = config.diff.left;
      var offset = initialLeft + diff;
      var constrained = isContrained(config);
      var size = initialSize + diff;

      onResizeDrop({
        index: index,
        constrained: constrained,
        initialLeft: initialLeft,
        region: region,
        diff: diff,
        offset: offset,
        size: size,
        column: column
      });
    }
  });
};

var _dragHelper = require('drag-helper');

var _dragHelper2 = _interopRequireDefault(_dragHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var emptyFn = function emptyFn() {};