'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Column = exports.ColumnGroup = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactFlex = require('react-flex');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _assignDefined = require('assign-defined');

var _assignDefined2 = _interopRequireDefault(_assignDefined);

var _join = require('./join');

var _join2 = _interopRequireDefault(_join);

var _reactLoadMask = require('react-load-mask');

var _reactLoadMask2 = _interopRequireDefault(_reactLoadMask);

var _getIndexBy = require('./utils/getIndexBy');

var _getIndexBy2 = _interopRequireDefault(_getIndexBy);

var _sorty = require('sorty');

var _sorty2 = _interopRequireDefault(_sorty);

var _clamp = require('./utils/clamp');

var _clamp2 = _interopRequireDefault(_clamp);

var _paginate = require('./utils/paginate');

var _paginate2 = _interopRequireDefault(_paginate);

var _Body = require('./Body');

var _Body2 = _interopRequireDefault(_Body);

var _ColumnGroup = require('./Body/ColumnGroup');

var _ColumnGroup2 = _interopRequireDefault(_ColumnGroup);

var _rowSelect = require('./rowSelect');

var _rowSelect2 = _interopRequireDefault(_rowSelect);

var _Column = require('./Column');

var _Column2 = _interopRequireDefault(_Column);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCREEN_HEIGHT = global.screen && global.screen.height;

var isSortControlled = function isSortControlled(props) {
  return props.sortInfo !== undefined;
};
var notEmpty = function notEmpty(x) {
  return !!x;
};
var emptyFn = function emptyFn() {};
var emptyObject = Object.freeze ? Object.freeze({}) : {};

var arrayOrObject = function arrayOrObject(obj) {
  return Array.isArray(obj) ? 'array' : 'object';
};

var DataGrid = function (_Component) {
  _inherits(DataGrid, _Component);

  function DataGrid(props) {
    _classCallCheck(this, DataGrid);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(DataGrid).call(this, props));

    var dataSource = props.dataSource;


    var loading = dataSource && (!!dataSource.then || typeof dataSource == 'function');
    var isArray = Array.isArray(dataSource);

    var data = isArray ? dataSource : [];

    _this.state = {
      focused: false,

      originalData: data,
      data: data,
      loading: loading,

      skip: props.defaultSkip,
      limit: props.limit,

      selected: props.defaultSelected,
      activeIndex: props.defaultActiveIndex,
      sortInfo: props.defaultSortInfo || props.sortInfo || {}
    };
    return _this;
  }

  _createClass(DataGrid, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        this.focus();
      }

      this.loadSourceData(this.props.dataSource);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextState) {
      var propsArrOrObject = arrayOrObject(this.props.defaultSortInfo);
      var nextPropsArrOrObject = arrayOrObject(nextProps.defaultSortInfo);

      if (propsArrOrObject != nextPropsArrOrObject) {
        // in order to react to defaultSortInfo type change
        // and update the state from multi to single sort, or the other way around
        this.setState({
          sortInfo: nextProps.defaultSortInfo || {}
        });
      }

      if (this.props.dataSource !== nextProps.dataSource) {
        var preparedProps = this.prepareProps(nextProps, (0, _objectAssign2.default)({}, this.state, nextState));
        this.loadSourceData(nextProps.dataSource, null, preparedProps);
      }

      // if (this.props.sortInfo != nextProps.sortInfo) {
      //   setTimeout(() => {
      //     this.setData(null, { sortInfo: nextProps.sortInfo })
      //   }, 0)
      // }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (!prevProps.autoFocus && this.props.autoFocus && !this.isFocused()) {
        this.focus();
      }
    }
  }, {
    key: 'isFocused',
    value: function isFocused() {
      return !!this.state.focused;
    }
  }, {
    key: 'render',
    value: function render() {
      var preparedProps = this.p = this.prepareProps(this.props, this.state);

      var columns = preparedProps.columns;
      var header = preparedProps.header;
      var loading = preparedProps.loading;
      var className = preparedProps.className;
      var children = preparedProps.children;
      var activeIndex = preparedProps.activeIndex;
      var hasNavigation = preparedProps.hasNavigation;


      return _react2.default.createElement(
        _reactFlex.Flex,
        _extends({
          column: true,
          flex: true,
          alignItems: 'stretch',
          wrap: false,
          tabIndex: hasNavigation ? 0 : null
        }, this.props, {
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          onKeyDown: this.onKeyDown,
          className: className
        }),
        loading && this.renderLoadMask(),
        _react2.default.createElement(_Body2.default, _extends({}, preparedProps, {
          onScrollBottom: this.onScrollBottom,
          ref: 'body',
          onRowClick: this.onRowClick,
          onHeaderCellClick: this.onHeaderCellClick,
          onHeaderSortClick: this.onHeaderSortClick
        }))
      );
    }
  }, {
    key: 'renderLoadMask',
    value: function renderLoadMask() {
      var props = {
        visible: this.p.loading,
        className: 'react-datagrid__load-mask'
      };

      if (this.p.renderLoadMask) {
        return this.p.renderLoadMask(props);
      }

      return _react2.default.createElement(_reactLoadMask2.default, props);
    }
  }, {
    key: 'onScrollBottom',
    value: function onScrollBottom(event) {
      this.props.onScrollBottom();

      if (this.props.livePagination) {
        this.gotoNextPage();
      }
    }
  }, {
    key: 'focus',
    value: function focus() {
      (0, _reactDom.findDOMNode)(this).focus();
    }
  }, {
    key: 'onFocus',
    value: function onFocus(event) {
      this.setState({
        focused: true
      });

      this.props.onFocus(event);
    }
  }, {
    key: 'onBlur',
    value: function onBlur(event) {
      this.setState({
        focused: false
      });

      this.props.onBlur(event);
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(event) {
      var key = event.key;


      this.props.onKeyDown(event);

      var handled = void 0;

      if (key == 'ArrowUp') {
        this.incrementActiveIndex(-1);
        handled = true;
      }
      if (key == 'ArrowDown') {
        this.incrementActiveIndex(1);
        handled = true;
      }

      if (key == 'Home') {
        this.changeActiveIndex(0);
        handled = true;
      }
      if (key == 'End') {
        this.changeActiveIndex(this.p.data.length - 1);
        handled = true;
      }

      if (key == 'PageUp') {
        this.incrementActiveIndex(this.props.keyPageStep * -1);
        handled = true;
      }
      if (key == 'PageDown') {
        this.incrementActiveIndex(this.props.keyPageStep);
        handled = true;
      }

      if (handled) {
        event.preventDefault();
      }
    }
  }, {
    key: 'onRowClick',
    value: function onRowClick(event, rowProps) {
      this.handleSelection(rowProps, event);
      this.changeActiveIndex(rowProps.realIndex);
    }
  }, {
    key: 'incrementActiveIndex',
    value: function incrementActiveIndex(dir) {
      this.changeActiveIndex(this.state.activeIndex + dir);
    }
  }, {
    key: 'changeActiveIndex',
    value: function changeActiveIndex(newIndex) {
      if (!this.p.hasNavigation) {
        return;
      }

      newIndex = (0, _clamp2.default)(newIndex, 0, this.p.data.length - 1);

      if (newIndex === this.p.activeIndex) {
        //if the new index is the same with the current index, do nothing
        return;
      }

      if (newIndex != null) {
        var scrollTop = this.getScrollTop();
        var bodyHeight = this.getBodyHeight();
        var rowScrollTop = newIndex * this.props.rowHeight;

        // scroll to item if is not visible
        if (scrollTop > rowScrollTop) {
          this.scrollToIndex(newIndex);
        }

        // bottom
        if (scrollTop + bodyHeight < rowScrollTop + this.props.rowHeight) {
          this.scrollToIndex(newIndex, { position: 'bottom' });
        }
      }

      this.setState({
        activeIndex: newIndex
      });

      this.props.onActiveIndexChange(newIndex);
    }
  }, {
    key: 'onHeaderCellClick',
    value: function onHeaderCellClick(event, props) {}
  }, {
    key: 'onHeaderSortClick',
    value: function onHeaderSortClick(props) {
      var column = this.getColumn(props.absoluteIndex);

      this.p.isMultiSort ? this.handleMultipleSort(column) : this.handleSingleSort(column);
    }

    /**
     * On single sort when you click on a sortable column it will begin
     * to change between it's three states
     * if you click on a new column the sortInfo overwritten with the
     * new sortInfo detemined by the new column
     */

  }, {
    key: 'handleSingleSort',
    value: function handleSingleSort(column) {
      var currentSortInfo = this.p.sortInfo;

      // if click on different column must start from begining
      var newSortInfo = this.getNewSortInfoDescription(column, currentSortInfo && currentSortInfo.absoluteIndex === column.absoluteIndex && currentSortInfo.dir);

      this.setSortInfo(newSortInfo);
    }

    /**
     * On multiselect, when you click on one toggle between it's state
     * if direction is 0, we remove i
     * TODO: do multisort
     */

  }, {
    key: 'handleMultipleSort',
    value: function handleMultipleSort(column) {
      var sortInfo = this.p.sortInfo;

      var newSortInfo = void 0;
      if (!sortInfo.length) {
        newSortInfo = [this.getNewSortInfoDescription(column)];
      } else {
        var sortInfoIndex = (0, _getIndexBy2.default)(sortInfo, 'absoluteIndex', column.absoluteIndex);
        var existingColumnSortInfo = sortInfo[sortInfoIndex];

        var newColumnSortInfo = this.getNewSortInfoDescription(column, existingColumnSortInfo ? existingColumnSortInfo.dir : null);

        if (existingColumnSortInfo) {
          //replace the existing with the new
          newSortInfo = [].concat(_toConsumableArray(sortInfo.slice(0, sortInfoIndex)), [newColumnSortInfo], _toConsumableArray(sortInfo.slice(sortInfoIndex + 1)));
        } else {
          newSortInfo = [].concat(_toConsumableArray(sortInfo), [newColumnSortInfo]);
        }
      }

      this.setSortInfo(newSortInfo.filter(notEmpty));
    }
  }, {
    key: 'getNewSortInfoDescription',
    value: function getNewSortInfoDescription(column, dir) {
      var newSortInfo = {};

      var newDir = void 0;

      if (!dir || dir === 0) {
        newDir = 1;
      } else if (dir === 1) {
        newDir = -1;
      } else if (dir === -1) {
        // newSortInfo shoud be null in this case
        // this means there is no sort
        // so there is no need to sort with nothing
        if (this.props.allowUnsort || this.p.isMultiSort) {
          return null;
        }
        newDir = 1;
      }

      newSortInfo.dir = newDir;

      // column cannot be sorted if it has no name and no sort function
      if (!column.name && !column.sort) {
        return;
      }

      if (column.name) {
        newSortInfo.name = column.name;
      }

      if (column.sort) {
        newSortInfo.fn = column.sort;
      }

      if (column.type) {
        newSortInfo.type = column.type;
      }

      newSortInfo.absoluteIndex = column.absoluteIndex;

      return newSortInfo;
    }
  }, {
    key: 'getColumn',
    value: function getColumn(index) {
      var columns = this.refs.body.component.getFlattenColumns();

      return columns[index];
    }
  }, {
    key: 'reload',
    value: function reload() {
      this.loadSourceData();
    }

    // handles source data it it is array, it is passed directly to setData
    // if is a promise, sets loading flat to true, when resolves passes data to setData

  }, {
    key: 'loadSourceData',
    value: function loadSourceData(dataSource, config, props) {
      var _this2 = this;

      config = config || emptyObject;
      props = props || this.p;

      if (dataSource === null) {
        this.setData(null);
        return;
      }

      if (dataSource === undefined) {
        dataSource = props.dataSource;
      }

      if (typeof dataSource == 'function') {
        dataSource = dataSource(props);
      }

      if (Array.isArray(dataSource)) {
        this.setData(dataSource, config);
      }

      if (dataSource.then) {
        if (props.onDataSourceResponse) {
          dataSource.then(props.onDataSourceResponse, props.onDataSourceResponse);
        }

        this.setLoading(true);

        dataSource.then(function (data) {
          var remoteCount = void 0;

          if (data.data) {
            remoteCount = data.count;
            data = data.data;
          }

          if (!Array.isArray(data)) {
            throw new Error('dataSource Promise did not return an array, it returned a ' + (typeof data === 'undefined' ? 'undefined' : _typeof(data)));
          }

          _this2.setData(data, (0, _objectAssign2.default)({ remoteCount: remoteCount }, config));
        });
      }
    }
  }, {
    key: 'setLoading',
    value: function setLoading(bool) {
      if (bool === undefined) {
        bool = true;
      }

      this.setState({
        loading: bool
      });
    }

    /**
     * Set the data array for the grid
     *
     * @param {Array/null} data - if data is null, the grid data will be reset to
     * the original data array.
     * @param {Object} [config]
     * @param {Number} [config.append]
     * @param {Number} [config.skip]
     * @param {Number} [config.limit]
     * @param {Number} [config.remoteCount]
     * @param {Number} [config.sortInfo]
     * @param {Object} [preparedProps]
     */

  }, {
    key: 'setData',
    value: function setData(data, config, preparedProps, callback) {
      var _this3 = this;

      config = config || emptyObject;
      if (callback === undefined && typeof preparedProps == 'function') {
        callback = preparedProps;
        preparedProps = null;
      }
      preparedProps = preparedProps || this.p;

      var newState = (0, _assignDefined2.default)({
        loading: false
      }, config);

      if (Array.isArray(data)) {
        if (preparedProps.livePagination && config.append) {
          data = [].concat(_toConsumableArray(this.state.originalData), _toConsumableArray(data));
        }
        //this is the new source of truth data array
        newState.originalData = data;
      } else {
        //get the original source of truth array
        data = this.state.originalData;
      }

      var sortInfo = newState.sortInfo !== undefined ? newState.sortInfo : preparedProps.sortInfo;

      var skip = newState.skip !== undefined ? newState.skip : preparedProps.skip;

      var limit = newState.limit !== undefined ? newState.limit : preparedProps.limit;

      var skipLimit = { skip: skip, limit: limit };

      data = this.sortData(data, sortInfo);
      data = this.paginateData(data, skipLimit, preparedProps);

      newState.data = data;

      // make dataMap only if selected is used
      if (this.isSelectionEnabled() && data !== null) {
        newState.dataMap = data.reduce(function (acc, item) {
          acc[_this3.getItemId(item)] = item;
          return acc;
        }, {});
      }

      this.setState(newState, callback);
    }
  }, {
    key: 'getItemId',
    value: function getItemId(item) {
      return item[this.props.idProperty];
    }

    /**
     * creates an object with props, that can come from
     * this.props, this.state, or computed
     * it is helpful to have a single point of access
     */

  }, {
    key: 'prepareProps',
    value: function prepareProps(props, state) {
      var loading = props.loading == undefined ? this.state.loading : props.loading;

      var selected = this.getSelected();
      var hasSelection = !this.isSelectionEmpty();

      /**
       * content height, is the hight of the container that holds all the rows, if the all the rows
       * are rendered, it is used for virtual scroll, based on it we know what to render
       */
      var contentHeight = props.rowHeight * (state.data ? state.data.length : 0) + props.scrollbarWidth;
      var isMultiselect = (typeof selected === 'undefined' ? 'undefined' : _typeof(selected)) === 'object' && selected !== null;

      // active index is used for rows navigation
      var activeIndex = props.activeIndex !== undefined ? props.activeIndex : this.state.activeIndex;
      var hasNavigation = activeIndex !== undefined;
      var isActiveIndexControlled = this.props.activeIndex !== undefined;

      // sortInfo
      // if is controleld use props, if not sortinfo
      var sortControlled = isSortControlled(this.props);

      var sortInfo = sortControlled ? props.sortInfo : this.state.sortInfo;
      var isMultiSort = Array.isArray(sortInfo);

      var data = state.data;
      var skip = props.skip === undefined ? state.skip : props.skip;

      props = (0, _objectAssign2.default)({}, props, (0, _assignDefined2.default)({}, {
        skip: skip,
        remoteCount: this.state.remoteCount,
        loading: loading,
        selected: selected,
        hasSelection: hasSelection,
        contentHeight: contentHeight,
        isMultiselect: isMultiselect,
        data: data,
        activeIndex: activeIndex,
        isActiveIndexControlled: isActiveIndexControlled,
        hasNavigation: hasNavigation,
        sortInfo: sortInfo,
        isMultiSort: isMultiSort,
        isSortControlled: sortControlled
      }));

      props.className = this.prepareClassName(props);

      return props;
    }
  }, {
    key: 'prepareClassName',
    value: function prepareClassName(props) {
      var borders = props.showCellBorders;

      return (0, _join2.default)(props.className, 'react-datagrid', this.state.focused && 'react-datagrid--focused', borders && 'react-datagrid--cell-borders-' + (borders === true ? 'both' : borders));
    }

    // exposed methods on body component

  }, {
    key: 'scrollAt',
    value: function scrollAt(scrollTop) {
      return this.refs.body.component.scrollAt(scrollTop);
    }
  }, {
    key: 'scrollToIndex',
    value: function scrollToIndex() {
      var _refs$body$component;

      return (_refs$body$component = this.refs.body.component).scrollToIndex.apply(_refs$body$component, arguments);
    }
  }, {
    key: 'scrollToId',
    value: function scrollToId() {
      var _refs$body$component2;

      return (_refs$body$component2 = this.refs.body.component).scrollToId.apply(_refs$body$component2, arguments);
    }
  }, {
    key: 'getScrollTop',
    value: function getScrollTop() {
      return this.refs.body.component.getScrollTop();
    }
  }, {
    key: 'getBodyHeight',
    value: function getBodyHeight() {
      return this.refs.body.component.getBodyHeight();
    }
  }, {
    key: 'getSelected',
    value: function getSelected() {
      return this.isSelectionControlled() ? this.props.selected : this.state.selected;
    }
  }, {
    key: 'getActiveIndex',
    value: function getActiveIndex() {
      return this.p.activeIndex;
    }
  }, {
    key: 'isSelectionControlled',
    value: function isSelectionControlled() {
      return this.props.selected !== undefined;
    }
  }, {
    key: 'isSelectionEnabled',
    value: function isSelectionEnabled() {
      var selected = this.props.selected;
      var defaultSelected = this.props.defaultSelected;

      return selected !== undefined || defaultSelected !== undefined;
    }

    /**
     * selected can be an object is case of multiselect
     * or a string or number in case of single select
     */

  }, {
    key: 'isSelectionEmpty',
    value: function isSelectionEmpty() {
      var selected = this.getSelected();
      var selectionEmpty = false;

      if (selected === undefined) {
        selectionEmpty = true;
      }

      if ((typeof selected === 'undefined' ? 'undefined' : _typeof(selected)) === 'object' && selected !== null) {
        selectionEmpty = Object.keys(selected).length === 0;
      }

      return selectionEmpty;
    }
  }, {
    key: 'isRemoteData',
    value: function isRemoteData(props) {
      props = props || this.props;

      if (!props.dataSource) {
        return false;
      }

      return !!props.dataSource.then || typeof props.dataSource == 'function';
    }
  }, {
    key: 'isPagination',
    value: function isPagination(props) {
      return !!props.pagination;
    }
  }, {
    key: 'isRemotePagination',
    value: function isRemotePagination(props) {
      props = props || this.props;

      var _props = props;
      var remotePagination = _props.remotePagination;
      var pagination = _props.pagination;


      if (pagination == 'local' || remotePagination === false) {
        return false;
      }

      return pagination == 'remote' || remotePagination === true || remotePagination === undefined && this.isRemoteData(this.props);
    }
  }, {
    key: 'isRemoteSort',
    value: function isRemoteSort(props) {
      props = props || this.props;

      var _props2 = props;
      var remoteSort = _props2.remoteSort;


      return remoteSort === true || remoteSort === undefined && this.isRemoteData(this.props);
    }
  }, {
    key: 'sortData',
    value: function sortData(data, sortInfo) {
      if (!sortInfo) {
        return data;
      }

      if (this.isRemoteSort()) {
        return data;
      }

      return (0, _sorty2.default)(sortInfo, [].concat(_toConsumableArray(data)));
    }

    /**
     * Sorting
     *   order of sort change
     * - if none, then 1 (asc)
     * - if 1, then -1 (desc)
     * - if -1, then 0 (none)
     */

  }, {
    key: 'setSortInfo',
    value: function setSortInfo(sortInfo) {
      var _this4 = this;

      this.props.onSortInfoChange(sortInfo);

      if (this.p.isSortControlled) {
        return;
      }

      this.setData(null, { sortInfo: sortInfo, skip: 0 }, function () {
        if (_this4.isRemoteSort()) {
          _this4.loadSourceData();
        }
      });
    }

    ///////////// PAGINATION RELATED STUFF ///////////

  }, {
    key: 'paginateData',
    value: function paginateData(data, _ref, props) {
      var skip = _ref.skip;
      var limit = _ref.limit;

      props = props || this.props;
      if (this.isPagination(props) && !this.isRemotePagination(props)) {
        data = (0, _paginate2.default)(data, { skip: skip, limit: limit });
      }

      return data;
    }
  }, {
    key: 'incrementSkip',
    value: function incrementSkip(amount, props) {
      props = props || this.p;

      this.setSkip(props.skip + amount);
    }
  }, {
    key: 'setSkip',
    value: function setSkip(value) {
      var _this5 = this;

      if (this.props.onSkipChange) {
        this.props.onSkipChange(value);
      }

      var controlled = this.props.skip !== undefined;

      if (controlled) {
        return;
      }

      var append = !!this.props.livePagination;

      this.setData(null, { skip: value, append: append }, function () {
        if (_this5.isRemotePagination()) {
          _this5.loadSourceData(undefined, { append: append });
        }
      });
    }
  }, {
    key: 'hasNextPage',
    value: function hasNextPage(props) {
      return this.getCurrentPage(props) < this.getPageCount(props);
    }
  }, {
    key: 'hasPrevPage',
    value: function hasPrevPage(props) {
      return this.getCurrentPage(props) > 1;
    }
  }, {
    key: 'getCurrentPage',
    value: function getCurrentPage(props) {
      props = props || this.p;

      return Math.ceil((props.skip - 1) / props.limit) + 1; //it's 1 based
    }
  }, {
    key: 'getPageCount',
    value: function getPageCount(props) {
      props = props || this.p;

      var data = this.state.originalData || props.data;
      var count = props.remoteCount !== undefined ? props.remoteCount : data.length;

      return Math.ceil(count / props.limit);
    }
  }, {
    key: 'gotoPage',
    value: function gotoPage(page, props) {
      props = props || this.p;

      //page is 1-based
      page = (0, _clamp2.default)(page, 1, this.getPageCount(props));

      if (page === this.getCurrentPage(props)) {
        return;
      }

      this.setSkip(props.limit * (page - 1));
    }
  }, {
    key: 'gotoLastPage',
    value: function gotoLastPage(props) {
      this.gotoPage(this.getPageCount(props));
    }
  }, {
    key: 'gotoFirstPage',
    value: function gotoFirstPage() {
      this.gotoPage(1);
    }
  }, {
    key: 'gotoNextPage',
    value: function gotoNextPage(props) {
      props = props || this.p;

      if (this.hasNextPage(props)) {
        this.incrementSkip(props.limit, props);
      }
    }
  }, {
    key: 'gotoPrevPage',
    value: function gotoPrevPage(props) {
      props = props || this.p;

      if (this.hasPrevPage(props)) {
        this.incrementSkip(-props.limit, props);
      }
    }
  }]);

  return DataGrid;
}(_reactClass2.default);

DataGrid.defaultProps = {
  defaultSkip: 0,
  limit: 100,
  showCellBorders: true,
  keyPageStep: 10,
  defaultLoading: false,
  header: true,
  onFocus: emptyFn,
  onBlur: emptyFn,
  onKeyDown: emptyFn,
  onRowMouseEnter: emptyFn,
  onRowMouseLeave: emptyFn,
  onScrollBottom: emptyFn,
  onActiveIndexChange: emptyFn,
  onSortInfoChange: emptyFn,
  rowProps: {},
  defaultSelected: undefined,
  scrollbarWidth: 20,
  rowPlaceholder: false,
  defaultSortInfo: null,
  sortable: true,
  resizable: true,
  allowUnsort: true,
  rowHeight: 40,
  columnMinWidth: 50,
  columnMaxWidth: null
};

DataGrid.propTypes = {
  idProperty: _react.PropTypes.string.isRequired,
  loading: _react.PropTypes.bool,
  header: _react.PropTypes.bool,
  defaultLoading: _react.PropTypes.bool,
  allowUnsort: _react.PropTypes.bool,

  // row config
  onRowMouseEnter: _react.PropTypes.func,
  onRowMouseLeave: _react.PropTypes.func,

  /**
   * TODO: refactor find a more elengant way of declaring placeholder
   * you should be able to configure placeholder global on dataGrid
   * and also on ColumnGroup
   */
  rowPlaceholder: _react.PropTypes.bool,
  renderRowPlaceholder: _react.PropTypes.func,
  rowPlaceholderDelay: _react.PropTypes.number,

  // scrolling and scroll
  onScroll: _react.PropTypes.func,
  onScrollBottom: _react.PropTypes.func,
  scrollToIndex: _react.PropTypes.func,
  scrollToId: _react.PropTypes.func,
  scrollbarWidth: _react.PropTypes.number,

  // selection
  selected: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string, _react.PropTypes.object]),
  defaultSelected: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string, _react.PropTypes.object]),
  onSelectionChange: _react.PropTypes.func,

  resizable: _react.PropTypes.bool,

  // sort
  sortable: _react.PropTypes.bool,
  defaultSortInfo: _react.PropTypes.oneOfType([_react.PropTypes.arrayOf(_react.PropTypes.object), _react.PropTypes.object]),
  sortInfo: _react.PropTypes.oneOfType([_react.PropTypes.arrayOf(_react.PropTypes.object), _react.PropTypes.object]),
  onSortInfoChange: _react.PropTypes.func,

  // navigation
  activeIndex: _react.PropTypes.number,
  defaultActiveIndex: _react.PropTypes.number,
  onActiveIndexChange: _react.PropTypes.func,

  // columns config
  columns: _react.PropTypes.arrayOf(function (props, propName) {
    var column = props[propName];
    if (!column.name && typeof column.render != 'function') {
      return new Error('column ' + propName + ' should have a "name" prop or a "render" function!');
    }
  }),
  children: function children(props, propName) {
    var children = props[propName];

    _react2.default.Children.map(children, function (child) {
      if (!child || !child.props || !child.props.isColumnGroup || !child.props.isColumn) {
        return new Error('The only children allowed of Datagrid are ColumnGroup and Column');
      }
    });
  },

  // data
  dataSource: function dataSource(props, propName) {
    var dataSource = props[propName];

    if (dataSource === undefined) {
      return new Error('dataSource prop is required.');
    }

    if (dataSource !== null && typeof dataSource !== 'function' && !Array.isArray(dataSource) && !(dataSource && dataSource.then)) {
      return new Error('dataSource must be an array, null, a promise or a function returning a promise.');
    }
  },
  onDataSourceResponse: _react.PropTypes.func
};

DataGrid.prototype = (0, _objectAssign2.default)(DataGrid.prototype, _rowSelect2.default);

exports.default = DataGrid;


// you can configurate the grid using an array of configuration objects
// or declaratively (jsx) using ColumnGroup and Column.
exports.ColumnGroup = _ColumnGroup2.default;
exports.

// Column is a dummy component only used for configuration
Column = _Column2.default;